
TYPO3.Flow - Bug # 31997

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category: Security
Created: 2011-11-22 Assigned To: Sebastian Kurfuerst
Updated: 2012-03-20 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: Security Context::hasRole should also work recursively; this makes <f:security.ifHasRole> work recursively 

as well
Description

Security Context::getRoles() returns ALL roles, while Security Context::hasRole checks only inside the first-level roles of the token.
This needs to be fixed and made consistent.

Associated revisions
Revision 861231e1 - 2012-03-20 10:32 - Sebastian Kurfuerst

[BUGFIX] Context::hasRole() now checks roles recursively

Previously, hasRole() only considered the first level of roles of a
token. getRoles() instead always considered all roles, including those
on a lower level.

This patch fixes the behavior of hasRole() by checking for roles
recursively. As before, the "Everybody" role is a role even non-
authenticated and anonymous users have.

This also fixes <f:security.ifHasRole>, as this ViewHelper directly uses
Context::getRoles.

Fixes: #31997
Releases: 1.1
Change-Id: I4a2c5ed8013c1d2a02dd569da6efa4101a5f7792

History
#1 - 2011-11-22 17:14 - Mr. Jenkins

Patch set 1 of change I4a2c5ed8013c1d2a02dd569da6efa4101a5f7792 has been pushed to the review server.
It is available at http://review.typo3.org/6859

#2 - 2011-11-24 12:39 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#3 - 2011-12-18 19:00 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6859

#4 - 2011-12-22 08:51 - Karsten Dambekalns
- Target version changed from 1.0.2 to 1.0.3

#5 - 2012-01-10 12:47 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6859

#6 - 2012-03-07 18:52 - Karsten Dambekalns
- Target version changed from 1.0.3 to 1.0.4

#7 - 2012-03-20 09:58 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6859

#8 - 2012-03-20 10:06 - Karsten Dambekalns
- Target version changed from 1.0.4 to 1.1

#9 - 2012-03-20 10:31 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6859

#10 - 2012-03-20 10:32 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/6859

#11 - 2012-03-20 14:39 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:861231e1eff72b53d3dd415c496bed2b29752358.
